[APIO2015]八邻旁之桥——非旋转treap
题目链接:
对于$k=1$的情况:
对于起点和终点在同侧的直接计入答案;对于不在同侧的,可以发现答案就是所有点坐标与桥坐标的差之和+起点与终点不在同一侧的人数。
将所有点排序,要使答案最优,桥坐标就是这些点坐标的中位数,用平衡树维护一下求中位数即可。
对于$k=2$的情况:
同样先将起点和终点在同侧的直接计入答案。显然两座桥比一座更优,我们将每个人的起点与终点坐标看成一条线段。那么对于每条线段,它的中点离哪座桥近它就走哪座桥更优。我们将每条线段按中点坐标排序,将所有线段分为两部分,显然左边部分选靠左的桥、右边部分选择靠右的桥。那么只需要枚举中间的分界线,然后两部分分别按$k=1$考虑就行。维护两棵平衡树,每次将第二棵中的两个点(被划为左半部分的线段的起点和终点)删除,插入到第一棵中。
#include<set>
#include<map>
#include<queue>
#include<stack>
#include<cmath>
#include<vector>
#include<cstdio>
#include<bitset>
#include<cstring>
#include<iostream>
#include<algorithm>
#define ll long long
using namespace std;
int ls[200010];
int rs[200010];
int size[200010];
int v[200010];
ll sum[200010];
int r[200010];
int n,k;
int cnt;
int tot;
int root;
ll ans;
ll res;
int L,R;
int x,y,z;
int a[200010];
char s[2],t[2];
struct lty
{
int x,y;
}p[100010];
bool operator < (lty a,lty b){return a.x+a.y<b.x+b.y;}
int newnode(int x)
{
int rt=++cnt;
r[rt]=rand();
size[rt]=1;
v[rt]=x;
sum[rt]=x;
return rt;
}
void pushup(int rt)
{
size[rt]=size[ls[rt]]+size[rs[rt]]+1;
sum[rt]=sum[ls[rt]]+sum[rs[rt]]+v[rt];
}
int merge(int x,int y)
{
if(!x||!y)
{
return x+y;
}
if(r[x]<r[y])
{
rs[x]=merge(rs[x],y);
pushup(x);
return x;
}
else
{
ls[y]=merge(x,ls[y]);
pushup(y);
return y;
}
}
void split(int rt,int &x,int &y,int k)
{
if(!rt)
{
x=y=0;
return ;
}
if(size[ls[rt]]>=k)
{
y=rt;
split(ls[rt],x,ls[y],k);
}
else
{
x=rt;
split(rs[rt],rs[x],y,k-size[ls[rt]]-1);
}
pushup(rt);
}
void split2(int rt,int &x,int &y,int k)
{
if(!rt)
{
x=y=0;
return ;
}
if(v[rt]>=k)
{
y=rt;
split2(ls[rt],x,ls[y],k);
}
else
{
x=rt;
split2(rs[rt],rs[x],y,k);
}
pushup(rt);
}
int build(int l,int r)
{
if(l==r)
{
return newnode(a[l]);
}
int mid=(l+r)>>1;
return merge(build(l,mid),build(mid+1,r));
}
int del(int &rt,int k)
{
split2(rt,x,y,k);
split(y,y,z,1);
rt=merge(x,z);
return y;
}
void ins(int &rt,int k,int id)
{
split2(rt,x,y,k);
rt=merge(merge(x,id),y);
}
void solve1()
{
for(int i=1;i<=n;i++)
{
scanf("%s%d%s%d",s,&x,t,&y);
if(s[0]==t[0])
{
ans+=abs(y-x);
}
else
{
ans++;
a[++tot]=x;
a[++tot]=y;
}
}
if(tot==0)
{
printf("%lld",ans);
return ;
}
sort(a+1,a+1+tot);
root=build(1,tot);
int mid=(size[root]+1)/2;
split(root,x,y,mid-1);
split(y,y,z,1);
ans+=1ll*size[x]*v[y]-sum[x];
ans+=sum[z]-1ll*size[z]*v[y];
root=merge(merge(x,y),z);
printf("%lld",ans);
}
void solve2()
{
for(int i=1;i<=n;i++)
{
scanf("%s%d%s%d",s,&x,t,&y);
if(s[0]==t[0])
{
ans+=abs(x-y);
}
else
{
ans++;
tot++;
p[tot].x=x,p[tot].y=y;
a[tot*2-1]=x,a[tot*2]=y;
}
}
if(tot==0)
{
printf("%lld",ans);
return ;
}
sort(p+1,p+1+tot);
sort(a+1,a+1+tot*2);
root=build(1,tot*2);
L=0,R=root;
ll mn=1ll<<60;
for(int i=1;i<=tot;i++)
{
res=0;
int l=del(R,p[i].x);
int r=del(R,p[i].y);
ins(L,v[l],l);
ins(L,v[r],r);
int mid=(size[L]+1)/2;
split(L,x,y,mid-1);
split(y,y,z,1);
res+=1ll*size[x]*v[y]-sum[x];
res+=sum[z]-1ll*size[z]*v[y];
L=merge(merge(x,y),z);
mid=(size[R]+1)/2;
split(R,x,y,mid-1);
split(y,y,z,1);
res+=1ll*size[x]*v[y]-sum[x];
res+=sum[z]-1ll*size[z]*v[y];
R=merge(merge(x,y),z);
mn=min(mn,res);
}
ans+=mn;
printf("%lld",ans);
}
int main()
{
scanf("%d%d",&k,&n);
if(k==1)solve1();
else solve2();
}
[APIO2015]八邻旁之桥——非旋转treap的更多相关文章
- 洛谷 P3644 [APIO2015]八邻旁之桥 解题报告
P3644 [APIO2015]八邻旁之桥 题目描述 一条东西走向的穆西河将巴邻旁市一分为二,分割成了区域\(A\)和区域\(B\). 每一块区域沿着河岸都建了恰好\(1000000001\)栋的建筑 ...
- [BZOJ4071][APIO2015]八邻旁之桥
BZOJ(这题是BZOJ权限题,有权限号的就去看看吧) Luogu(良心洛谷) 题目描述 一条东西走向的穆西河将巴邻旁市一分为二,分割成了区域\(A\)和区域\(B\). 每一块区域沿着河岸都建了恰好 ...
- [APIO2015]八邻旁之桥
题面在这里 sol 这是一个\(Splay\)的题解 首先,如果一个人的家和办公室在同一侧,我们可以直接预处理; 如果不在同一侧,也可以加上1(当然要过桥啦) 当k==1时 我们设桥的位置为\(pos ...
- 题解【luoguP3644 [APIO2015]八邻旁之桥】
题目链接 题解 家和公司在同侧 简单,直接预处理掉 若 \(k=1\) 取所有的居民的\(\frac{家坐标+公司坐标}{2}\)的所有坐标的正中间建一座桥,使所有居民到的距离最小. 实现方法:线段树 ...
- [luoguP3644] [APIO2015]八邻旁之桥(权值线段树)
传送门 首先如果起点终点都在同一侧可以直接处理,如果需要过桥答案再加1 对于k等于1的情况 桥的坐标为x的话,a和b为起点和终点坐标 $ans=\sum_{1}^{n} abs(a_{i}-x)+ab ...
- 洛谷 P3644 [APIO2015]八邻旁之桥(对顶堆维护中位数)
题面传送门 题意: 一条河将大地分为 \(A,B\) 两个部分.两部分均可视为一根数轴. 有 \(n\) 名工人,第 \(i\) 名的家在 \(x_i\) 区域的 \(a_i\) 位置,公司在 \(y ...
- APIO2015 八邻旁之桥/巴邻旁之桥
题目描述: bz luogu 题解: 贪心+权值线段树. $K=1$的时候,答案为$\sum |x-l| + |x-r|$,所以所有端点排序后取中位数即可. $K=2$的时候,一定是左边的一些走左边的 ...
- 【BZOJ4071】八邻旁之桥(线段树)
[BZOJ4071]八邻旁之桥(线段树) 题面 BZOJ权限题,洛谷链接 题解 既然\(k<=2\) 那么,突破口就在这里 分类讨论 ①\(k=1\) 这...不就是中位数吗.... 直接把所有 ...
- 【BZOJ4071】[Apio2015]巴邻旁之桥 Treap
[BZOJ4071][Apio2015]巴邻旁之桥 Description 一条东西走向的穆西河将巴邻旁市一分为二,分割成了区域 A 和区域 B. 每一块区域沿着河岸都建了恰好 1000000001 ...
随机推荐
- 转 无损转换Image为Icon
不可取 var handle = bmp.GetHicon(); //得到图标句柄return Icon.FromHandle(handle); //通过句柄得到图标 可取 /// <su ...
- webstrom设置语句中的分号
webstrom可以设置语句默认是否添加分号 setting >editor > Code Style > Javascript
- Ext之页面多次请求问题(下拉框发送无关请求)
extjs 下拉框在拉取本地数据,然后又要展示后台数据时,出现过此问题(加载页面,自动发送无关的请求导致后台出现错误日志) { xtype:'combo', id:'state', width:130 ...
- navigator(浏览器对象)Screen对象(屏幕)
浅谈navigator对象: 注意:不是所有浏览器都支持 .cookieEnabled 判断是否启用了cookie 在客户端硬盘持久保存用户私密数据的小文件 .plugins 浏览器安装的所有插件 ...
- 简单记录一次注入到shell
0x00 前言 帮朋友之前拿的一个站,有点久了没有完整截图,简单记录一下. 0x01 基础信息 操作系统:win 集成环境:phpstudy 端口开放:82,3306,3389 有phpmyadmin ...
- iOS开发-NSString去掉所有换行及空格
1.去掉字符串两端的空格及回车 - (NSString *)removeSpaceAndNewline:(NSString *)str{ NSString *temp = [str stringByT ...
- ABAP Netweaver体内的那些寄生式编程语言
今天这篇文章的主题是:寄生. Jerry最近看到朋友圈里一位朋友分享的一张寄居蟹的照片,对于Jerry这种在内地长大的又很宅的人来说,没有机会看到寄居蟹,所以觉得很新鲜: 寄居蟹主要以螺壳为寄体,寄居 ...
- Jerry Wang从2017年到2019年的自由泳学习笔记
打腿 把注意力调整到脚部,尽量不要让他打出水面,因为在空气中大腿完全是无用功,但是如果只是脚跟出水一点,倒也没什么关心,但是主观上,要控制一下,如果你听到你的打腿是"咚咚咚咚"这样 ...
- SDL图解
1.什么是SDL 2.为什么要用SDL 3.SDL由哪几个阶段组成 用于规范公司web应用开发流程:安全需求分析.代码检查.安全测试... 4.微软的SDL实施流程
- 【charlse】charlse功能
(一)主界面介绍 一.工具导航栏 Charles 顶部为菜单导航栏,菜单导航栏下面为工具导航栏.视图如下图所示: 工具导航栏中提供了几种常用工具: :清除捕获到的所有请求 :红点状态说明正在捕获请 ...